﻿using C1.Win.C1FlexGrid;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace C1FlexGrid_CustomFilterMenu_CS
{
    public partial class Form1 : Form
    {

        Form filterForm = new Form();
        int col;

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            C1FlexGrid1.AllowFiltering = true;
            C1FlexGrid1.AllowSorting = AllowSortingEnum.None;
            C1FlexGrid1.MouseClick += C1FlexGrid1_MouseClick;

            DataTable dt = new DataTable();
            dt.Columns.Add("ID");
            dt.Columns.Add("Name");
            dt.Columns.Add("State");
            dt.Rows.Add(1, "Mike", "Sweden");
            dt.Rows.Add(2, "Mill", "Shanghai");
            dt.Rows.Add(3, "Park", "Newyork");
            dt.Rows.Add(4, "Ted", "California");
            dt.Rows.Add(5, "Louis", "Perth");
            C1FlexGrid1.DataSource = dt;
        }

        private void C1FlexGrid1_MouseClick(object sender, MouseEventArgs e)
        {
            if (C1FlexGrid1.HitTest(e.Location).Type == C1.Win.C1FlexGrid.HitTestTypeEnum.FilterIcon)
            {
                CustomFilterMenu();
                HitTestInfo hti = C1FlexGrid1.HitTest(e.X, e.Y);
                col = hti.Column;
            }
        }

        private void CustomFilterMenu()
        {
            foreach (Form frm in Application.OpenForms)
            {
                if (frm.Name == "FilterEditorForm" & frm.GetType().ToString() == "C1.Win.C1FlexGrid.FilterEditorForm")
                {
                    filterForm = frm;
                    filterForm.Width = filterForm.Width + 70;
                    frm.Refresh();

                    foreach (object item in filterForm.Controls)
                    {
                        dynamic ts = item as ToolStrip;
                        if (ts != null)
                        {
                            ToolStripButton tsASC = new ToolStripButton();
                            ToolStripButton tsDESC = new ToolStripButton();

                            tsASC.Text = "Sort Asc";
                            tsDESC.Text = "Sort Desc";

                            tsASC.Image = global::C1FlexGrid_CustomFilterMenu_CS.Properties.Resources.Upimage;
                            tsDESC.Image = global::C1FlexGrid_CustomFilterMenu_CS.Properties.Resources.Downimage;

                            tsASC.ImageScaling = ToolStripItemImageScaling.None;
                            tsASC.ImageTransparentColor = Color.White;

                            tsDESC.ImageScaling = ToolStripItemImageScaling.None;
                            tsDESC.ImageTransparentColor = Color.White;

                            tsASC.Click += tsASC_Click;
                            tsDESC.Click += tsDESC_Click;

                            ts.Items.Add(tsASC);
                            ts.Items.Add(tsDESC);
                        }

                    }

                    frm.Refresh();
                }
            }
        }

        private void tsASC_Click(object sender, EventArgs e)
        {
            C1FlexGrid1.Sort(SortFlags.Ascending, col);
            filterForm.Close();
        }

        private void tsDESC_Click(object sender, EventArgs e)
        {
            C1FlexGrid1.Sort(SortFlags.Descending, col);
            filterForm.Close();
        }
    }
}
